// DS2450DlgDlg.cpp : implementation file
//

#include "stdafx.h"
#include "DS2450Dlg.h"
#include "DS2450DlgDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

// initialize static data members
BOOL CDS2450DlgDlg::m_AEH = FALSE;
BOOL CDS2450DlgDlg::m_AEL = FALSE;

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDS2450DlgDlg dialog

CDS2450DlgDlg::CDS2450DlgDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CDS2450DlgDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDS2450DlgDlg)
	m_btnAcheck = FALSE;
	m_btnBcheck = FALSE;
	m_btnCcheck = FALSE;
	m_btnDcheck = FALSE;
	m_channelChoice = -1;
	m_alarmHighCheck = FALSE;
	m_alarmLowCheck = FALSE;
	m_presetRadio = -1;
	m_voltageRadio = -1;
	m_outputEnableRadio = -1;
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CDS2450DlgDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDS2450DlgDlg)
	DDX_Control(pDX, IDC_ALARM_LOW_COMBO, m_alarmLowCombo);
	DDX_Control(pDX, IDC_ALARM_HIGH_COMBO, m_alarmHighCombo);
	DDX_Control(pDX, IDC_RESOLUTION_COMBO, m_resolutionCombo);
	DDX_Check(pDX, IDC_CH_A_CHECK, m_btnAcheck);
	DDX_Check(pDX, IDC_CH_B_CHECK, m_btnBcheck);
	DDX_Check(pDX, IDC_CH_C_CHECK, m_btnCcheck);
	DDX_Check(pDX, IDC_CH_D_CHECK, m_btnDcheck);
	DDX_Radio(pDX, IDC_CH_A_RADIO, m_channelChoice);
	DDX_Check(pDX, IDC_AEH_CHECK, m_alarmHighCheck);
	DDX_Check(pDX, IDC_AEL_CHECK, m_alarmLowCheck);
	DDX_Radio(pDX, IDC_PRESET0_RADIO, m_presetRadio);
	DDX_Radio(pDX, IDC_VOLTAGE256_RADIO, m_voltageRadio);
	DDX_Radio(pDX, IDC_OUTPUT_DISABLE_RADIO, m_outputEnableRadio);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CDS2450DlgDlg, CDialog)
	//{{AFX_MSG_MAP(CDS2450DlgDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_CH_A_CHECK, OnChACheck)
	ON_BN_CLICKED(IDC_CH_B_CHECK, OnChBCheck)
	ON_BN_CLICKED(IDC_CH_C_CHECK, OnChCCheck)
	ON_BN_CLICKED(IDC_CH_D_CHECK, OnChDCheck)
	ON_CBN_CLOSEUP(IDC_RESOLUTION_COMBO, OnCloseupResolutionCombo)
	ON_CBN_EDITCHANGE(IDC_RESOLUTION_COMBO, OnEditchangeResolutionCombo)
	ON_BN_CLICKED(IDC_PAGE0_BUTTON, OnPage0Button)
	ON_BN_CLICKED(IDC_PAGE1_BUTTON, OnPage1Button)
	ON_BN_CLICKED(IDC_PAGE2_BUTTON, OnPage2Button)
	ON_BN_CLICKED(IDC_READ_BUTTON, OnReadButton)
	ON_BN_CLICKED(IDC_WRITE_BUTTON, OnWriteButton)
	ON_BN_CLICKED(IDC_EXIT_BUTTON, OnExitButton)
	ON_BN_CLICKED(IDC_CH_A_RADIO, OnChARadio)
	ON_BN_CLICKED(IDC_CH_B_RADIO, OnChBRadio)
	ON_BN_CLICKED(IDC_CH_C_RADIO, OnChCRadio)
	ON_BN_CLICKED(IDC_CH_D_RADIO, OnChDRadio)
	ON_BN_CLICKED(IDC_VOLTAGE256_RADIO, OnVoltage256Radio)
	ON_BN_CLICKED(IDC_VOLTAGE512_RADIO, OnVoltage512Radio)
	ON_BN_CLICKED(IDC_AEH_CHECK, OnAEHCheck)
	ON_BN_CLICKED(IDC_AEL_CHECK, OnAELCheck)
	ON_CBN_CLOSEUP(IDC_ALARM_HIGH_COMBO, OnCloseupAlarmHighCombo)
	ON_CBN_EDITCHANGE(IDC_ALARM_HIGH_COMBO, OnEditchangeAlarmHighCombo)
	ON_BN_CLICKED(IDC_PRESET0_RADIO, OnPreset0Radio)
	ON_BN_CLICKED(IDC_PRESET1_RADIO, OnPreset1Radio)
	ON_BN_CLICKED(IDC_NOPRESET_RADIO, OnNopresetRadio)
	ON_BN_CLICKED(IDC_OUTPUT_DISABLE_RADIO, OnOutputDisableRadio)
	ON_BN_CLICKED(IDC_OUTPUT_ENABLE_TRANS_ON_RADIO, OnTransOnRadio)
	ON_BN_CLICKED(IDC_OUTPUT_ENABLED_TRANS_OFF_RADIO, OnTransOffRadio)
	ON_CBN_CLOSEUP(IDC_ALARM_LOW_COMBO, OnCloseupAlarmLowCombo)
	ON_CBN_EDITCHANGE(IDC_ALARM_LOW_COMBO, OnEditchangeAlarmLowCombo)
	ON_BN_CLICKED(IDC_CLEAR_ALARM_BUTTON, OnClearAlarmButton)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDS2450DlgDlg message handlers

BOOL CDS2450DlgDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here

	//display 2450 info
	AfxMessageBox(my2450.driverInfo, MB_OK | MB_ICONINFORMATION);
	this->SetWindowText(my2450.ROMStr);

	//initialize Dialog data
	m_writtenFlag = TRUE;
	m_btnAcheck = FALSE;
	m_btnBcheck = FALSE;
	m_btnCcheck = FALSE;
	m_btnDcheck = FALSE;
	m_channelChoice = 0;  //channel A  is starting point
	UpdateData(FALSE);

	Get2450Settings(0x01);  //get settings for channel A

	//init resolution combo list
	char iStr[4] ={0};
	for (int  j = 1; j <17; j++)
	{
		sprintf(iStr,"%d",j);
		m_resolutionCombo.AddString(iStr);
	}
	
	//init alarm combo lists
	char fStr[10] = {0};
	float thresh = 0;

	for (int i = 0; i < 26; i++)
	{
		sprintf(fStr,"%1.2f ",thresh);
		m_alarmHighCombo.AddString(fStr);
		m_alarmLowCombo.AddString(fStr);
		thresh += 0.2;
	}

	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CDS2450DlgDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CDS2450DlgDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CDS2450DlgDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

//-------------------------------------------------------------------
//OnChACheck
//displays the voltage reading  for channel A when the check box is 
//checked

void CDS2450DlgDlg::OnChACheck() 
{
	char szVoltage[8] ={0};
	BOOL A,B,C,D;

	UpdateData(); //get current data from dialog

	CWnd * pWnd = GetDlgItem( IDC_VOLT_A_STATIC ); //get pointer to data window
	ASSERT (pWnd != NULL);
	if (m_btnAcheck)							//update voltage reading display
		sprintf(szVoltage,"%2.5f", my2450.getVoltageReading(0x01));
	if(pWnd)
		pWnd->SetWindowText( szVoltage );
	
	my2450.getChannels(A,B,C,D);               //update 2450
	my2450.setChannels(m_btnAcheck, B,C,D);
}

//-------------------------------------------------------------------
//OnChBCheck
//displays the voltage reading for channel B when the check box is 
//checked
void CDS2450DlgDlg::OnChBCheck() 
{
	char szVoltage[8] ={0};
	BOOL A,B,C,D;

	UpdateData();            //get current data from dialog

	CWnd * pWnd = GetDlgItem( IDC_VOLT_B_STATIC ); //get pointer to data window
	ASSERT (pWnd != NULL);
	if (m_btnBcheck)                             //update voltage reading display
		sprintf(szVoltage,"%2.5f", my2450.getVoltageReading(0x02));
	if(pWnd)
		pWnd->SetWindowText( szVoltage );
	
	my2450.getChannels(A,B,C,D);           //update 2450
	my2450.setChannels(A,m_btnBcheck,C,D);
}

//-------------------------------------------------------------------
//OnChCCheck
//displays the voltage reading for channel C when the check box is 
//checked
void CDS2450DlgDlg::OnChCCheck() 
{
	char szVoltage[8] ={0};
	BOOL A,B,C,D;

	UpdateData();                       //get current data from dialog

	CWnd * pWnd = GetDlgItem( IDC_VOLT_C_STATIC ); //get pointer to data window
	ASSERT (pWnd != NULL);
	if (m_btnCcheck)                    //update voltage reading display
		sprintf(szVoltage,"%2.5f", my2450.getVoltageReading(0x04));
	if(pWnd)
		pWnd->SetWindowText( szVoltage );

	
	my2450.getChannels(A,B,C,D);          //update 2450	
	my2450.setChannels(A,B,m_btnCcheck,D);
}

//-------------------------------------------------------------------
//OnChDCheck
//displays the voltage reading for channel D when the check box is 
//checked
void CDS2450DlgDlg::OnChDCheck() 
{
	char szVoltage[8] ={0};
	BOOL A,B,C,D;

	UpdateData();           //get current data from dialog

	CWnd * pWnd = GetDlgItem( IDC_VOLT_D_STATIC );  //get pointer to data window
	ASSERT (pWnd != NULL);
	if (m_btnDcheck)                           //update voltage reading display
		sprintf(szVoltage,"%2.5f", my2450.getVoltageReading(0x08));
	if(pWnd)
		pWnd->SetWindowText( szVoltage );

	
	my2450.getChannels(A,B,C,D);                  //update 2450
	my2450.setChannels(A,B,C,m_btnDcheck);
}

//-------------------------------------------------------------------
//OnCloseupResolutionCombo
//updates resolution based on user choice form the list
void CDS2450DlgDlg::OnCloseupResolutionCombo() 
{
	CString szChoice;
	int nChoice;
	int nResolution;

	m_writtenFlag = FALSE; //new control data for 2450

	m_resolutionCombo.GetWindowText(szChoice);
	nChoice = m_resolutionCombo.GetCurSel();

	//user has chosen from the list
	if(nChoice != CB_ERR) 
	{
		m_resolutionCombo.GetLBText( nChoice, szChoice);
		nResolution = atoi(szChoice);
		m_curResolution = (unsigned char) nResolution;
	}

	//update the Alarm Settings to match with the new resolution
	OnEditchangeAlarmHighCombo();
	OnEditchangeAlarmLowCombo();
}

//--------------------------------------------------------------------
//OnEditchangeResolutionCombo
//validates the user input and keeps track of current resolution
void CDS2450DlgDlg::OnEditchangeResolutionCombo() 
{
	CString szChoice;
	int nLength;
	int nResolution;

	m_writtenFlag = FALSE; //new control data for 2450;
	m_resolutionCombo.GetWindowText(szChoice);

	if (!szChoice.IsEmpty()) //window hasn't been simply cleared
	{
		nLength=szChoice.GetLength();
		//if input is not ok
		if ((nLength > 2) ||                         //string too long
			(!isdigit(szChoice[0])) ||				 //first char is not numeric
			((nLength==2) && !isdigit(szChoice[1])) || //second char exists & isn't numberic
			((nResolution = atoi(szChoice)) < 0) ||  //conversion to int is bad
			(nResolution < 1) ||					 //number is out of range
			(nResolution > 16))
		{
			AfxMessageBox("Resolution must be from 1 to 16 bits!");
		}
		//input is ok
		else 
		{
			m_curResolution = (unsigned char) nResolution;
		}
	}

	//update the alarm settings to match with the new resolution
	OnEditchangeAlarmHighCombo();
	OnEditchangeAlarmLowCombo();
}


//---------------------------------------------------------------------
//OnPage0button
//dumps the output page from the 2450 memory
void CDS2450DlgDlg::OnPage0Button() 
{
	char msg[40];
	my2450.DumpPage(0,msg);
	AfxMessageBox(msg);
	
}

//---------------------------------------------------------------------
//OnPage1button
//dumps the control page from the 2450 memory
void CDS2450DlgDlg::OnPage1Button() 
{
	char msg[40];
	my2450.DumpPage(1,msg);
	AfxMessageBox(msg);
	
}

//---------------------------------------------------------------------
//OnPage2button
//dumps the alarm settings page from the 2450 memory
void CDS2450DlgDlg::OnPage2Button() 
{
	char msg[40];
	my2450.DumpPage(2,msg);
	AfxMessageBox(msg);
	
}

//----------------------------------------------------------------------
//OnReadButton
//Reads the voltage from the 2450
void CDS2450DlgDlg::OnReadButton() 
{
	int response;
	if (m_writtenFlag == FALSE)
	{
		response = AfxMessageBox("The control settings for the current \n"
			          "channel have not been written to the button \n"
					  "Do you want to write them before reading?", MB_YESNO | MB_ICONQUESTION);
		if (response == IDYES)
			OnWriteButton();
	}

	my2450.ReadVoltage();

	UpdateData();      //ensure we have the current data for check boxes
	
	char szAVoltage[8] ={0};
	char szBVoltage[8] ={0};
	char szCVoltage[8] ={0};
	char szDVoltage[8] ={0};


	//for each open channel, get the reading and display
	if (m_btnAcheck)
	{
		CWnd * pAWnd = GetDlgItem( IDC_VOLT_A_STATIC );
		ASSERT (pAWnd != NULL);
		sprintf(szAVoltage,"%2.5f", my2450.getVoltageReading(0x01));
		if(pAWnd)
			pAWnd->SetWindowText( szAVoltage );
	}
	if (m_btnBcheck)
	{
		CWnd * pBWnd = GetDlgItem( IDC_VOLT_B_STATIC );
		ASSERT (pBWnd != NULL);
		sprintf(szBVoltage,"%2.5f", my2450.getVoltageReading(0x02));
		if(pBWnd)
			pBWnd->SetWindowText( szBVoltage );
	}
	if (m_btnCcheck)
	{
		CWnd * pCWnd = GetDlgItem( IDC_VOLT_C_STATIC );
		ASSERT (pCWnd != NULL);
		sprintf(szCVoltage,"%2.5f", my2450.getVoltageReading(0x04));
		if(pCWnd)
			pCWnd->SetWindowText( szCVoltage );
	}
	if (m_btnDcheck)
	{
		CWnd * pDWnd = GetDlgItem( IDC_VOLT_D_STATIC );
		ASSERT (pDWnd != NULL);
		sprintf(szDVoltage,"%2.5f", my2450.getVoltageReading(0x08));
		if(pDWnd)
			pDWnd->SetWindowText( szDVoltage );
	}	

	//Check Alarm Flags and display any Alarms
	BOOL Hflag, Lflag, printFlag;
	uchar nChan[4] = {0x01,0x02,0x04,0x08};
	char cChan[4] ={'A','B','C','D'};
	int i;

	CString szAlarmMsg("Alarms were set for the following channels:\n");
	
	printFlag = FALSE;
	for (i=0; i<4; i++)
	{
		if (my2450.getAlarmH(nChan[i]))
			Hflag = my2450.getAlarmHFlag(nChan[i]);
		else 
			Hflag = FALSE;

		if (my2450.getAlarmL(nChan[i]))
			Lflag = my2450.getAlarmLFlag(nChan[i]);
		else 
			Lflag = FALSE;
		
		if (Hflag)
		{
			printFlag = TRUE;
			szAlarmMsg = szAlarmMsg + cChan[i] + " High\n";
		}
		if (Lflag)
		{
			printFlag = TRUE;
			szAlarmMsg = szAlarmMsg + cChan[i] + " Low\n";
		}

	}

	if (printFlag)
		AfxMessageBox(szAlarmMsg, MB_ICONEXCLAMATION | MB_OK);
}


//------------------------------------------------------------------------
//OnWriteButton
//writes the current channel settings to the 2450
void CDS2450DlgDlg::OnWriteButton() 
{
	uchar addr;

	switch (m_channelChoice)
	{
	case 0:
		addr = 0x01;
		break;
	case 1:
		addr = 0x02;
		break;
	case 2:
		addr = 0x04;
		break;
	case 3:
		addr = 0x08;
		break;
	}

	my2450.setResolution(addr,m_curResolution);
	my2450.setOutputEnable(addr,m_outEnable,m_transistorOff);
	my2450.setAlarmH(addr,m_alarmHighCheck);
	my2450.setAlarmHSetting(addr,m_alarmHighSet);
	my2450.setAlarmL(addr,m_alarmLowCheck);
	my2450.setAlarmLSetting(addr,m_alarmLowSet);
	my2450.setVoltageRange(addr,m_voltRange);
	my2450.setPreset(addr,m_preset,m_preclear);

	m_writtenFlag = TRUE;
}

//------------------------------------------------------------------------
//OnExitButton
//Exits the dialog box
void CDS2450DlgDlg::OnExitButton() 
{
  OnOK();	
}




//----------------------------------------------------------------------
//OnChARadio
//changes the channel options if appropriate
void CDS2450DlgDlg::OnChARadio() 
{
	int response;

	if (!m_writtenFlag)
	{
		response = MessageBox("Changes to the previous channel have \n"
			       "not been written to the device.\n"
				   "Do you want to change channels anyway?\n", "DS2450", 
				   MB_YESNO | MB_ICONEXCLAMATION);
		if (response == IDNO)
		{
			UpdateData(FALSE);
			return;
		}
		m_writtenFlag = TRUE;
	}
	m_channelChoice = 0;
	
	Get2450Settings(0x01);
	
	CWnd* pWnd = GetDlgItem( IDC_CH_CHOICE_STATIC );
	ASSERT ( pWnd != NULL);
	if (pWnd)
		pWnd->SetWindowText( "CHANNEL A");
}

//----------------------------------------------------------------------
//OnChBRadio
//changes the channel options if appropriate
void CDS2450DlgDlg::OnChBRadio() 
{
	int response;
	
	if (!m_writtenFlag)
	{
		response = MessageBox("Changes to the previous channel have \n"
			       "not been written to the device.\n"
				   "Do you want to change channels anyway?\n", "DS2450", 
				   MB_YESNO | MB_ICONEXCLAMATION);
		if (response == IDNO)
		{
			UpdateData(FALSE);
			return;
		}
		m_writtenFlag = TRUE;
	}
	m_channelChoice = 1;

	Get2450Settings(0x02);

	CWnd* pWnd = GetDlgItem( IDC_CH_CHOICE_STATIC );
	ASSERT ( pWnd != NULL);
	if (pWnd)
		pWnd->SetWindowText( "CHANNEL B");

}

//----------------------------------------------------------------------
//OnChCRadio
//changes the channel options if appropriate
void CDS2450DlgDlg::OnChCRadio() 
{
	int response;

	if (!m_writtenFlag)
	{
		response = MessageBox("Changes to the previous channel have \n"
			       "not been written to the device.\n"
				   "Do you want to change channels anyway?\n", "DS2450", 
				   MB_YESNO | MB_ICONEXCLAMATION);
		if (response == IDNO)
		{
			UpdateData(FALSE);
			return;
		}
		m_writtenFlag = TRUE;
	}
	m_channelChoice = 2;

	Get2450Settings(0x04);	

	CWnd* pWnd = GetDlgItem( IDC_CH_CHOICE_STATIC );
	ASSERT ( pWnd != NULL);
	if (pWnd)
		pWnd->SetWindowText( "CHANNEL C");
}

//----------------------------------------------------------------------
//OnChDRadio
//changes the channel options if appropriate
void CDS2450DlgDlg::OnChDRadio() 
{
	int response;

   
	if (!m_writtenFlag)
	{
		response = MessageBox("Changes to the previous channel have \n"
			       "not been written to the device.\n"
				   "Do you want to change channels anyway?\n", "DS2450", 
				   MB_YESNO | MB_ICONEXCLAMATION);
		if (response == IDNO)
		{
			UpdateData(FALSE);
			return;
		}
		m_writtenFlag = TRUE;
	}
	m_channelChoice = 3;
 
	Get2450Settings(0x08);
	
	CWnd* pWnd = GetDlgItem( IDC_CH_CHOICE_STATIC );
	ASSERT ( pWnd != NULL);
	if (pWnd)
		pWnd->SetWindowText( "CHANNEL D");
}

//--------------------------------------------------------------------------------
//OnVoltage256Radio
//Updates the alarm thresholds and voltage in accordance with the chosen threshold
void CDS2450DlgDlg::OnVoltage256Radio() 
{
	m_writtenFlag = FALSE;
	m_voltageRadio = 0;
	m_voltRange = 0;
	//update the Alarm Settings to match with the new voltage
	OnEditchangeAlarmHighCombo();
	OnEditchangeAlarmLowCombo();
}

//--------------------------------------------------------------------------------
//OnVoltage512Radio
//Updates the alarm thresholds and voltage in accordance with the chosen threshold
void CDS2450DlgDlg::OnVoltage512Radio() 
{
	m_writtenFlag = FALSE;
	m_voltageRadio = 1;
	m_voltRange = 1;
	//update the Alarm Settings to match with the new voltage
	OnEditchangeAlarmHighCombo();
	OnEditchangeAlarmLowCombo();
}


//------------------------------------------------------------------------------
//OnAEHCheck
//note setting change
void CDS2450DlgDlg::OnAEHCheck() 
{
	m_writtenFlag = FALSE;
	if (m_AEH)
		m_AEH = m_alarmHighCheck = FALSE;
	else
		m_AEH = m_alarmHighCheck = TRUE;	
}

//------------------------------------------------------------------------------
//OnAELCheck
//note setting change
void CDS2450DlgDlg::OnAELCheck() 
{
	m_writtenFlag = FALSE;
	if (m_AEL)
		m_AEL = m_alarmLowCheck = FALSE;
	else
		m_AEL = m_alarmLowCheck = TRUE;
}

//-------------------------------------------------------------------------------
//OnCloseupAlarmHighCombo
//updates alarm high setting based on user choice from list
void CDS2450DlgDlg::OnCloseupAlarmHighCombo() 
{
	CString szChoice;
	int nChoice;
	char szAlarm[9] = {0};
	float fSetting;
	float vRange;
	
	nChoice = m_alarmHighCombo.GetCurSel();
		
	if (nChoice != CB_ERR)
	{
		m_writtenFlag = FALSE;
		m_alarmHighCombo.GetLBText( nChoice, szChoice);
	}

	fSetting = atof(szChoice);

	if (m_voltRange == 1)
		vRange = 5.12;
	else 
		vRange = 2.56;

	if ((fSetting < 0) || (fSetting > vRange))
	{
		AfxMessageBox("Alarm High Setting Out Of Range");
		m_alarmHighSet = 0xFF;
		return;
	}

	m_alarmHighSet = FloatToBin(fSetting);
}

//---------------------------------------------------------------------------------
//OnEditchangeAlarmHighCombo
//validates user input and keeps track of current alarm high threshold
void CDS2450DlgDlg::OnEditchangeAlarmHighCombo() 
{
	CString szChoice;
	float fChoice;
	float vRange;
		
	m_writtenFlag = FALSE;
	m_alarmHighCombo.GetWindowText(szChoice);

	fChoice = atof(szChoice);

	if (m_voltRange == TRUE)
		vRange = 5.12;
	else 
		vRange = 2.56;

	if ((fChoice <0) || (fChoice > vRange))
	{
		AfxMessageBox("Alarm High Setting Out of Range");
		m_alarmHighSet = 0xFF;
		return;
	}

	m_alarmHighSet = FloatToBin(fChoice);
}

//--------------------------------------------------------------------
//OnPreset0Radio
//Update the set and clear data to clear the voltage reading
void CDS2450DlgDlg::OnPreset0Radio() 
{
	m_writtenFlag = FALSE;
	m_preset = FALSE;
	m_preclear = TRUE;
	
}

//--------------------------------------------------------------------
//OnPreset1Radio
//Update the set and clear data to set the voltage reading
void CDS2450DlgDlg::OnPreset1Radio() 
{
	m_writtenFlag = FALSE;
	m_preset = TRUE;
	m_preclear = FALSE;
	
}

//--------------------------------------------------------------------
//OnNoPresetRadio
//Update the set and clear data to leave the voltage reading alone
void CDS2450DlgDlg::OnNopresetRadio() 
{
	m_writtenFlag = FALSE;
	m_preset = FALSE;
	m_preclear = FALSE;
	
}

//---------------------------------------------------------------------
//OnOutputDisableRadio
//Update the out enable and transistor data
void CDS2450DlgDlg::OnOutputDisableRadio() 
{
	m_writtenFlag = FALSE;
	m_outEnable = FALSE;
}

//---------------------------------------------------------------------
//OnTransOnRadio
//Update the out enable and transistor data
void CDS2450DlgDlg::OnTransOnRadio() 
{
	m_writtenFlag = FALSE;
	m_outEnable = TRUE;
	m_transistorOff = FALSE;

}

//---------------------------------------------------------------------
//OnTransOffRadio
//Update the out enable and transistor data
void CDS2450DlgDlg::OnTransOffRadio() 
{
	m_writtenFlag = FALSE;
	m_outEnable = TRUE;
	m_transistorOff = TRUE;
}


//--------------------------------------------------------------------
//OnCloseupAlarmLowCombo
//Validate and update the low alarm setting
void CDS2450DlgDlg::OnCloseupAlarmLowCombo() 
{
	CString szChoice;
	int nChoice;
	char szAlarm[9] = {0};
	float fSetting;
	float vRange;
	
	nChoice = m_alarmLowCombo.GetCurSel();
		
	if (nChoice != CB_ERR)
	{
		m_writtenFlag = FALSE;
		m_alarmLowCombo.GetLBText( nChoice, szChoice);
	}

	fSetting = atof(szChoice);

	if (m_voltRange == 1)
		vRange = 5.12;
	else 
		vRange = 2.56;

	if ((fSetting < 0) || (fSetting > vRange))
	{
		AfxMessageBox("Alarm Low Setting Out Of Range");
		m_alarmLowSet = 0x00;
		return;
	}

	m_alarmLowSet = FloatToBin(fSetting);
	
}


//-------------------------------------------------------------------
//OnEditChangeAlarmLowCombo
//Validate and Update the low alarm setting
void CDS2450DlgDlg::OnEditchangeAlarmLowCombo() 
{
	CString szChoice;
	float fChoice;
	float vRange;
		
	m_writtenFlag = FALSE;
	m_alarmLowCombo.GetWindowText(szChoice);

	fChoice = atof(szChoice);

	if (m_voltRange == TRUE)
		vRange = 5.12;
	else 
		vRange = 2.56;

	if ((fChoice <0) || (fChoice > vRange))
	{
		AfxMessageBox("Alarm Low Setting Out of Range");
		m_alarmLowSet = 0x00;
		return;
	}

	m_alarmLowSet = FloatToBin(fChoice);
	
}

void CDS2450DlgDlg::OnClearAlarmButton() 
{
	int i;
	uchar nChan[4] = {0x01,0x02,0x04,0x08};

	for ( i=0; i<4; i++)
	{
		my2450.setAlarmHFlag(nChan[i],FALSE);
		my2450.setAlarmLFlag(nChan[i],FALSE);
	}
}


///////////////////////////////////////////////////////////////////////////////
//Other Functions

//-----------------------------------------------------------------------
//StringToUchar
//converts an 8 character string of 'bits' into the corresponding
//unsigned character value
float CDS2450DlgDlg::StringToUchar(CString binary)
{
	
	unsigned char nBinary = 0;
	
	//compute nBinary
	for (int i = 0; i <8; i++)
	{
		if (binary[i] == '1')
			nBinary = (nBinary * 2) +1;
		else 
			nBinary = (nBinary * 2);
	}

    return nBinary;
}

//-----------------------------------------------------------------------------
//BinToFloat(uchar)
//Converts a uchar to a voltage given the current voltage range and resolution
float CDS2450DlgDlg::BinToFloat(uchar value)
{
	//contains  2^x in the x th index
	int PowersOfTwo[17] = {1,2,4,8,16,32,64,128,256,512,1024,2048,4096,8192,16384,32768,65536};

	float range;
	int resolution; 
	int nBinary;
   	float increment;
	float voltage;
	
	//get resolution 
	resolution = m_curResolution;
	
	//get range 
	if (m_voltageRadio == FALSE)
		range = 2.56;
	else 
		range = 5.12;

	nBinary = value;
	nBinary = nBinary << 8;	    //left shift 8 bits; byte is now in high order byte
	nBinary = nBinary >> (16-resolution); //right shift to get correct resolution on reading
	
	increment = range / PowersOfTwo[resolution];  //find increment of the reading
     									 
	voltage = nBinary * increment;  //calculate real voltage

    return voltage;
}

//-----------------------------------------------------------------------------
//FloatToBin 
//converts a voltage to its 8 bit equivalent given the 
//current voltage range and reolution
uchar CDS2450DlgDlg::FloatToBin(float value)
{
	//contains  2^x in the x th index
	int PowersOfTwo[17] = {1,2,4,8,16,32,64,128,256,512,1024,2048,4096,8192,16384,32768,65536};

	float range;
	int resolution; 
	float increment;
	int nBinary;
	uchar cValue;
	
	//get resolution 
	resolution = m_curResolution;
	
	//get range 
	if (m_voltageRadio == FALSE)
		range = 2.56;
	else 
		range = 5.12;

	increment = range / PowersOfTwo[resolution];  //find increment of the reading
    nBinary  = (int)(value/ increment);  //calculate binary equivalent

	if (resolution >8)
		nBinary = nBinary >> (8 - (16 - resolution)); //shift upper 8 bits of value to low byte
	cValue = (uchar) nBinary;
    return cValue;
}

//------------------------------------------------------------------------------
//Get2450Settings
//sets local values to those for the given channel
void CDS2450DlgDlg::Get2450Settings(uchar channel)
{
	char resStr[10] = {0};
	char AHStr[10] = {0};
	char ALStr[10] = {0};
	

	//read values
	m_curResolution = (my2450.getResolution(channel));
	my2450.getOutEnable(channel, m_outEnable, m_transistorOff);
	m_AEH =  my2450.getAlarmH(channel);
	m_alarmHighSet = my2450.getAlarmHSetting(channel);
	m_AEL =  my2450.getAlarmL(channel);
	m_alarmLowSet = my2450.getAlarmLSetting(channel);
	m_voltRange = my2450.getVoltageRange(channel);
	my2450.getPreset(channel, m_preset, m_preclear);

    //convert as necessary to dialog data
	if (m_outEnable)
	{
		if (m_transistorOff)
			m_outputEnableRadio = 2;
		else 
			m_outputEnableRadio = 1;
	}
	else
	{
		m_outputEnableRadio = 0;
	}

	m_alarmHighCheck = m_AEH;
	m_alarmLowCheck = m_AEL;

	if (m_voltRange)
		m_voltageRadio = 1;
	else 
		m_voltageRadio = 0;

	if (m_preclear)
		m_presetRadio = 0;
	else if (m_preset)
		m_presetRadio = 1;
	else 
		m_presetRadio = 2;

	sprintf(resStr,"%d",m_curResolution);
	m_resolutionCombo.SetWindowText(resStr);

	sprintf(AHStr,"%1.2f",BinToFloat(m_alarmHighSet));
	m_alarmHighCombo.SetWindowText(AHStr);

	sprintf(ALStr,"%1.2f",BinToFloat(m_alarmLowSet));
	m_alarmLowCombo.SetWindowText(ALStr);

	//update dialog data
	UpdateData(FALSE);
}


